% Los programas son para fines educativo y se ofrecen para uso publico en educacin
% Maestria en Ciencias de la Computacin.
% Dr. Carlos Barrn Romero
% Septiembre de 2018
%=============================================================
function [val, g, LJ_i] = FunLJb1(x)
% Funcion de LJ Normalizada
[n3]=length(x);

n = n3 / 3;
n2 = 2*n;

a = x(1:n);
b = x(n+1:n2);
c = x(n2+1:n3);

g=zeros(n3,1);
LJ_i=zeros(n,1);

val=0.0;
for i=1:n-1
    for j=i+1:n
        d2 = norm([a(i)-a(j); b(i)-b(j); c(i)-c(j)])^2;
        rij = (1.0/d2) * (1.0/d2) * (1.0/d2);
        val_ij = rij * rij - 2.0 * rij;
        val = val +  val_ij;
        LJ_i(i)=LJ_i(i) + val_ij;
        LJ_i(j)=LJ_i(j) + val_ij;
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        rij6 = (1.0/d2)^3;
        
        F1 = ( - rij6 * rij6 + rij6) / d2;
        
        dx = a(i)-a(j); 
        dy = b(i)-b(j); 
        dz = c(i)-c(j);
        
        gx = dx * F1;
        gy = dy * F1;
        gz = dz * F1;
        
        g(i)   = g(i)     + gx;
        g(i+n) = g(i+n)   + gy;
        g(i+n2) = g(i+n2) + gz;
        g(j)   = g(j)     - gx;
        g(j+n) = g(j+n)   - gy;
        g(j+n2) = g(j+n2) - gz;
        
    end;
end;

val = val;
LJ_i=LJ_i*4.0;
g = (12.0 * ones(n3,1)) .* g;
